/* *##% nuiton-processor - lib
 * Copyright (C) 2002 - 2009 CodeLutin
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Lesser Public License for more details.
 *
 * You should have received a copy of the GNU General Lesser Public
 * License along with this program.  If not, see
 * <http://www.gnu.org/licenses/lgpl-3.0.html>. ##%* */

/* *
* OptimisationProcessor.java
*
* Created: Wed Sep  4 2002
*
* @author  <poussin@codelutin.com>
* Copyright Code Lutin
* @version $Revision: 255 $
*
* Mise a jour: $Date: 2009-08-16 09:50:25 +0200 (dim., 16 août 2009) $
* par : $Author: tchemit $
*/

package org.nuiton.processor;

import java.io.*;
import org.nuiton.processor.filters.OptimisationFilter;

public class OptimisationProcessor extends Processor { // OptimisationProcessor

    public OptimisationProcessor(){
        setInputFilter(new OptimisationFilter());
    }

    static public void process(String filein, String fileout)
    throws IOException{
        Processor processor = new OptimisationProcessor();
        processor.process(new FileReader(filein), new FileWriter(fileout));
    }

    public static void main(String [] args)throws IOException{
        if(args.length < 2) {
            System.out.println("Give source and destination file");
            System.exit(1);
        } else {
            process(args[0], args[1]);
        }
    }

} // OptimisationProcessor
